#define _CRT_SECURE_NO_DEPRECATE

#define y1 y1______________

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>
#include <string.h>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <deque>
#include <queue>

#undef y1

using namespace std;

#define mp make_pair
#define pb push_back
#define fi(a,b) for (i=a;i<=b;i++)
#define fj(a,b) for (j=a;j<=b;j++)
#define fo(a,b) for (o=a;o<=b;o++)
#define fdi(a,b) for (i=a;i>=b;i--)
#define fdj(a,b) for (j=a;j>=b;j--)
#define fdo(a,b) for (o=a;o>=b;o--)
#define ZERO(x) memset(x,0,sizeof(x))
#define COPY(a,b) memcpy(a,b,sizeof(b))
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;
typedef vector <int> vi;
typedef pair<int, int> pii;
typedef vector <pii> vpii;

#define MAX 25

int n = 20, m = 14;

int dx[] = {1,1,1,0,0,-1,-1,-1};
int dy[] = {0,1,-1,-1,1,-1,0,1};

int label[MAX][MAX];
int color[MAX][MAX];

int e[MAX][MAX][MAX][MAX];

int bx, by;

bool Field(int x, int y) {
	if (x < 0 || x > n) return false;
	if (y < 0 || y > m) return false;
	return true;
}

bool Border(int x, int y) {
	if (x == 0 || x == n) return true;
	if (y == 0 || y == m) return true;
	return false;
}

bool MyGoal(int x, int y) {
	if (x == 0 && y > 5 && y < 9) return true;
	return false;
}

bool Goal(int x, int y) {
	if (x == 20 && y > 5 && y < 9) return true;
	return false;
}

int player;

vpii v;

int bst;

int sqr(int x) {
	return x * x;
}

int Dist(int x, int y) {
	if (Goal(x, y)) return 0;
	return sqr(sqr(x - 20)) + sqr(sqr(y - 7));
}

int dfs0(int x, int y) {
	int i;
	int x2, y2;

	if (Goal(x, y) || !Border(x, y) && !label[y][x]) {
		bst = min(bst, Dist(x, y));
		return false;
	}
	color[y][x] = 1;

	fi(0, 7) {
		x2 = x + dx[i];
		y2 = y + dy[i];
		if (MyGoal(x2, y2)) continue;
		if (!Field(x2, y2)) continue;
		if (!e[x][y][x2][y2]) continue;
		if (color[y2][x2]) continue;

		if (dfs0(x2, y2)) return true;

	}

	return false;

}

void bfs() {
	int i;
	int x, y;
	int x2, y2;
	pii p[MAX][MAX];

	queue <pii> qu;

	ZERO(p);

	qu.push(mp(bx, by));
	p[by][bx] = mp(-1, -1);
	color[by][bx] = 1;
	
	while (!qu.empty()) {
		x = qu.front().first;
		y = qu.front().second;
		qu.pop();
		if (Goal(x, y) || !Border(x, y) && !label[y][x]) {
			if (Dist(x, y) == bst) {
				break;
			}
			continue;
		}
		fi(0, 7) {
			x2 = x + dx[i];
			y2 = y + dy[i];
			if (MyGoal(x2, y2)) continue;
			if (!Field(x2, y2)) continue;
			if (!e[x][y][x2][y2]) continue;
			if (color[y2][x2]) continue;
			color[y2][x2] = 1;
			p[y2][x2] = mp(x, y);
			qu.push(mp(x2, y2));
		}
	}

	while (x != -1) {
		v.pb(mp(x, y));
		x2 = p[y][x].first;
		y2 = p[y][x].second;
		x = x2;
		y = y2;
	}
	reverse(v.begin(), v.end());
	
}

void Print(vpii v) {
	int i;

	printf("%d ", SIZE(v));
	if (player == 2) {
		printf("%d %d ", v[0].second, n - v[0].first);
	} else {
		printf("%d %d ", v[0].second, v[0].first);
	}
	fi(1, SIZE(v) - 1) {
		if (player == 2) {
			printf("%d %d ", v[i].second, n - v[i].first);
		} else {
			printf("%d %d ", v[i].second, v[i].first);
		}
		
		e[bx][by][v[i].first][v[i].second] = 0;
		e[v[i].first][v[i].second][bx][by] = 0;
		label[v[i].second][v[i].first] = 1;

		bx = v[i].first;
		by = v[i].second;
	}
	printf("\n");
	fflush(stdout);
}

void Move() {
	ZERO(color);
	v.clear();

	bst = 1000000;

	dfs0(bx, by);

	ZERO(color);

	bfs();
	
	Print(v);
}

void Init() {
	int i, j, o;
	int x2, y2;

	bx = 10;
	by = 7;

	ZERO(label);
	ZERO(e);
	fj(0, m) {
		fi(0, n) {
			fo(0, 7) {
				x2 = i + dx[o];
				y2 = j + dy[o];
				if (!Field(x2, y2)) continue;
				if (Border(i, j) && Border(x2, y2)) continue;
				e[i][j][x2][y2] = 1;
			}
		}
	}

	label[by][bx] = 1;
}

int main() {
	int i;
	int k;
	int x, y;
	int x2, y2;
	char str[1000];
	player = 2;
	Init();
	
	while (1) {
		scanf("%s", str);
		if (strcmp(str, "Name") == 0) {
			printf("Udsu 0.3b\n");
			fflush(stdout);
		} else if (strcmp(str, "Quit") == 0) {
			return 0;
		} else if (strcmp(str, "Start") == 0) {
			player = 1;
			Move();
		} else {
			sscanf(str, "%d", &k);
			scanf("%d %d", &y, &x);
			if (player == 2) x = n - x;
			fi(1, k - 1) {
				scanf("%d %d", &y2, &x2);
				if (player == 2) x2 = n - x2;
				label[y2][x2] = 1;
				e[x][y][x2][y2] = 0;
				e[x2][y2][x][y] = 0;
				x = x2;
				y = y2;
			}
			bx = x2;
			by = y2;
			Move();
		}
	}
	return 0;
}
