#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <iostream>
#include <sstream>
#include <string>
#include <cstring>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <vector>
#include <cmath>
#include <ctime>
#include <cassert>
#include <iomanip>
//#include <stack>

#pragma comment(linker, "/STACK:164777216")
using namespace std;


typedef long long ll;
typedef unsigned long long ull;

template<typename T> int size(T & a) {return (int)a.size();}
template<typename T> T sqr(T a) {return a * a;}

#define pb push_back
#define mp make_pair
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define _(a, b) memset((a), (b), sizeof(a))
#define REP(i, a, b) for(int i=(a); i<(b); ++i)
#define REPD(i, a, b) for(int i=(b) - 1; i >= (a); --i)
#define all(a) a.begin(),a.end()
#define sc second
#define fs first



const int MAXH = 15, MAXW = 21, MAXD = 7;
bool weStart=false;
const int INF = int(1e9);
int goal[2][3][2] = {
		 {
			 {6, 0}, {7, 0}, {8, 0} 
		 }, 
		 {
			{6, 20}, {7, 20}, {8, 20}
		 } };
bool isField(int x, int y) {
	return 0 <= x && x < MAXW && 0 <= y && y < MAXH;
}
struct path {
	vector<pii> pts;
	static path max(path &a, path &b) ;
	string toString() ;
};

struct field {
	int nowx, nowy;
	bool u[MAXH][MAXW];
	bool edges[MAXH][MAXW][MAXH][MAXW];
	void applyStep(int x1, int y1, int x2, int y2, bool add) {
		if (add) {
			u[y1][x1]=true;
			u[y2][x2]=true;
		}
		edges[y1][x1][y2][x2]=edges[y2][x2][y1][x1]=true;
	}
	bool d[MAXH][MAXW], can[MAXH][MAXW];
	int prvx[MAXH][MAXW], prvy[MAXH][MAXW];
	void bfs(int sx, int sy) {
		queue<pair<int, pii> > q;
		_(prvx, 255);
		_(prvy, 255);
		_(d, false);
		_(can, false);
		q.push(mp(0, mp(sy, sx)));
		d[sy][sx] = true;
		while (size(q)) {
			pair<int, pii>  p = q.front();
			int x=p.second.second;
			int y=p.second.first;
			q.pop();
			if (p.first == 1) {
				can[y][x]=true;
				continue;
			}
			for(int dx=-1; dx <= 1; dx++)
				for(int dy=-1; dy <= 1; ++dy) {
					if (dx==0 && dy==0)  continue;
					int nx = dx + x ;
					int ny = dy + y;
					if (!isField(nx, ny)) continue;
					if (edges[y][x][ny][nx])
						continue;
					if (d[ny][nx])
						continue;
					d[ny][nx] = true;
					prvx[ny][nx] = x;
					prvy[ny][nx] = y;
					if (u[ny][nx]) {
						q.push(mp(0, mp(ny, nx)));
					} else {
						q.push(mp(1, mp(ny, nx)));
					}
				}
		}
	}
	void readOpposite(const char *s) {
		string str(s);
		istringstream iss(str);
		int n;
		iss >> n;
		int prevX=-1, prevY=-1;
		REP(i, 0, n) {
			int y, x;
			iss >> y >> x;
			if (prevX==-1) {
		 	
			} else {
				applyStep(prevX, prevY, x, y, true);
			}
			prevX = x;
			prevY = y;
			nowx = x;
			nowy = y;
		}
	}
	int connectedPoint (int &sqrDist) {
		bfs(nowx, nowy);
		int cnt=0;
		sqrDist=INF;
		REP(y,0,MAXH) REP(x, 0, MAXW) {
			if (can[y][x])
				++cnt;
			if (!can[y][x])
				continue;
			int id = (weStart ? 0 : 1);
			REP(v, 0, 3)
				sqrDist = min(sqrDist, sqr(goal[id][v][0] - y) + sqr(goal[id][v][1] - x));
			bool inf = false;
			REP(v, 0, 3)
				if (goal[id][v][0] == y  &&
					goal[id][v][1] == x)
					inf = true;
			if (inf)
				return INF;
		}
		return cnt;
	}
	void reset() {
		_(u, false);
		_(edges, false);
		nowx = 10;
		nowy = 7;
		u[nowy][nowx]=true;
		REP(y, 0, MAXH) REP(x, 0, MAXW)
			if (y == 0 || x == 0 || y == MAXH-1 || x == MAXW-1) {
				bool ok=true;
				REP(v, 0, 2) REP(j ,0, 3) {
					if (y == goal[v][j][0] && x == goal[v][j][1])
						ok=false;
				}
				if (ok) {
					u[y][x]=true;
					if (x == 7 && y == 20) {
						int d = 1;
					}
				}
			}
		REP(y, 0, MAXH-1)  {
			applyStep(0, y, 0, y+1, false),
			applyStep(MAXW-1, y, MAXW-1, y+1, false);
		}
		REP(x, 0, MAXW-1) {
			applyStep(x, 0, x+1, 0, false);
			applyStep(x, MAXH-1, x+1, MAXH-1, false);
		}
	}
	field() {
		reset();
	}
	path generatePathFrom(int sx, int sy) {
		path ans ;
		assert(u[sy][sx]);
		bfs(sx, sy);
		REP(x, 0, MAXW) REP(y, 0, MAXH) {
			if (can[y][x]) {
				path cur = restorePath(x, y, sx, sy);
				ans = path::max(ans, cur);
			}
		}
		return ans;
	}
	path restorePath(int fx, int fy, int sx, int sy) {
		path w ;
		for(; fx != sx || sy != fy; ) {
			w.pts.pb(mp (fy, fx));
			int _fx = prvx[fy][fx];
			int _fy = prvy[fy][fx];
			fx = _fx;
			fy = _fy;
		}
		w.pts.pb(mp (sy, sx));
		reverse(all(w.pts));
		return w;
	}
	
};



int calcDistance(pii p) {
	int id = (weStart ? 1 : 0);
	int d1 = int(1e9);
	REP(i, 0, 3) {
		d1 = min(d1, sqr(p.first - goal[id][i][0]) + sqr(p.second - goal[id][i][1]));
	}
	return d1;
}

double evr(int distance, int connected, int length, int odist) {
	//cerr << a << " " << b << endl;
	if (distance == 0)
		return -INF;
	return 1.0 * distance / 100 + connected / 400.0  
		-length / 200.0 - odist / 50.0 ;
}
field f ;

	
path path::max(path &a, path &b) {
	if (size(a.pts) == 0) return b;
	if (size(b.pts) == 0) return a;
	int distance1 = (size(a.pts) == 0 ? INF : calcDistance(a.pts[size(a.pts)- 1]));
	int distance2 = (size(b.pts) == 0 ? INF : calcDistance(b.pts[size(b.pts) - 1]));
	int oDist1, oDist2;
	//return distance1 < distance2 ? a : b;
	field tmp=f;
	tmp.readOpposite(a.toString().c_str());
	int count1 = tmp.connectedPoint(oDist1);
	tmp = f;
	tmp.readOpposite(b.toString().c_str());
	int count2 = tmp.connectedPoint(oDist2);
	double d1 = evr(distance1, count1, size(a.pts), oDist1);
	double d2 = evr(distance2, count2, size(a.pts), oDist2);
	if (d1<d2) return a;
	return b;
}
string path::toString() {
	stringstream iss;
	assert(size(pts) > 0);
	iss << size(pts);
	iss << " ";
	REP(i,0,size(pts)) {
		iss << pts[i].first << " ";
		iss << pts[i].second;
		if (i != size(pts)) {
			iss << " ";
		}
	}
	return iss.str();
}

path best ;
int stx[MAXD+10];
int sty[MAXD+10];

void dfs(int pos, int x, int y, field &f, int depth) {
	if (depth >= MAXD)
		return;
	stx[pos] = x;
	sty[pos] = y;
	if (!f.u[y][x]) {
		path tmp ;
		REP(i,0,pos+1) {
			tmp.pts.push_back(mp(sty[i], stx[i]));
		}
		best = path::max(best, tmp);
	} else {
		for(int dx=-1; dx <= 1; ++dx)
			for(int dy=-1; dy <= 1; ++dy) {
				if (dx==0 && dy==0)
					continue;
				int nx = dx + x;
				int ny = dy + y;
				if (!isField(nx, ny)) continue;
				if (f.edges[y][x][ny][nx])
					continue;
				f.applyStep(x, y, nx, ny, false);
				
				dfs(pos+1, nx, ny, f, depth+1);
				f.edges[y][x][ny][nx]=f.edges[ny][nx][y][x]=false;
			}
	}
}

char buffer[10000];

void output(string s) {
	cout << s;
	cout << endl;
	cout.flush();
}









int dfs1=0, bfs1=0;
string doTurn() {
	path ans = f.generatePathFrom(f.nowx, f.nowy);
	best.pts.clear();
	dfs(0, f.nowx, f.nowy, f, 0);
	ans = path::max(ans, best);
	if (best.pts == ans.pts) ++ dfs1;
	else ++bfs1;
	f.readOpposite(ans.toString().c_str());
	return ans.toString();
}
void solve() {

	string str = doTurn();

	output(str);
}
int main() { 

#ifdef air
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	//freopen("err.txt", "w", stderr);
	
	gets(buffer);
	if (strcmp(buffer, "Name") == 0) {
		output("Gideon 2.0");
	} else {
		assert(false);
	}
	f.reset();
	for(;;) {
		gets(buffer);
		if (strcmp(buffer, "Quit") == 0) {
		//	cerr << "dfs iter : " << dfs1 << " " << "bfs iter : " << bfs1 << endl;
			exit(0);
		}
		
		if (strcmp(buffer, "Start") == 0) {
			weStart=true;
		} else {
			f.readOpposite(buffer);
		}
		solve();
	}
		

#ifdef air
    printf("\n\n%.3lf\n", clock() * 1.0 / CLOCKS_PER_SEC);
#endif
}